/*

   CREATE FUNCTION log_error RETURNS INTEGER SONAME "udf_log_error.so";
	 select log_error('My error message...');
   DROP FUNCTION log_error;

*/

#ifdef STANDARD
/* STANDARD is defined, don't use any mysql functions */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#ifdef __WIN__
typedef unsigned __int64 ulonglong;   /* Microsofts 64 bit types */
typedef __int64 longlong;
#else
typedef unsigned long long ulonglong;
typedef long long longlong;
#endif /*__WIN__*/
#else
#include <my_global.h>
#include <my_sys.h>
#if defined(MYSQL_SERVER)
#include <m_string.h>   /* To get strmov() */
#else
/* when compiled as standalone */
#include <string.h>
#define strmov(a,b) stpcpy(a,b)
#define bzero(a,b) memset(a,0,b)
#define memcpy_fixed(a,b,c) memcpy(a,b,c)
#endif
#endif
#include <mysql.h>
#include <ctype.h>

#ifdef HAVE_DLOPEN

my_bool log_error_init(UDF_INIT *initid, UDF_ARGS *args, char *message)
{
  if (args->arg_count == 1)
	{
    args->arg_type[0]= STRING_RESULT;
  }
  else
  {
    strmov(message, "Wrong number of arguments to print to stderr. Only one is allowed.");
    return 1;
  }

	int length = (uint) args->lengths[0];
	if ( length >= 256 )
	{
    strmov(message, "Argument too long. Only up to 256 chars are allowed.");
    return 2;
  }

  return 0;
}

void log_error_deinit(UDF_INIT *initid)
{
}

longlong log_error(UDF_INIT *initid __attribute__((unused)), UDF_ARGS *args,
                         char *is_null __attribute__((unused)), char *error __attribute__((unused)))
{
	ut_print_timestamp(stderr);

	if ( ! args->args[0] )
	{
	  // no output here
		return 0;
	}

	fprintf(stderr, " %s\n", args->args[0]);

	return 0;
}

#endif /* HAVE_DLOPEN */
